#!/usr/bin/perl

use NDBM_File;
use Fcntl;
use diagnostics;
use Getopt::Std;

sub _gethostbyname($name) {
	my $name = shift;
	my $dotted_quad_ip;
	my ($a, $b, $c, $d);
	my $ip_pack = gethostbyname $name; 
	unless (defined $ip_pack) {
		return $name;
	}
	($a, $b, $c, $d) = unpack('C4', $ip_pack);
	$dotted_quad_ip = "$a.$b.$c.$d";
	return $dotted_quad_ip;
}

sub ReadFileAcct($dir, $file) {
	my $dir = shift;
	my $file = shift;
	my %dict;
	open FD, "<$dir$file" or die "Cannot open file $file $!";
	while (<FD>) {
		if (/#/) {next;}
		if (/^\s*$/) {next;}
		/([\w-\.]+)\s+([\s\w-:]+)/;
		$dict{&_gethostbyname($1)} = $2;
	}
	close FD;
	return \%dict;
}

getopt("f", \%opts); 

$dictref = &ReadFileAcct("./", $opts{"f"});
%dict = %$dictref;

tie(%hash, NDBM_File, "$opts{'f'}", O_RDWR|O_CREAT, 0644);
%hash = %dict;
untie %hash;

